Kubernetes

IONOS Cloud Managed Kubernetes (K8s) consist of two central building blocks:

First, the Kubernetes cluster provides the control plane, although it is not directly visible.

Second, the node pools provide the worker nodes. While these are visible in a VDC, as Kubernetes is built on top of the compute engine, i.e., servers, volumes, etc.

Get Kubernetes Clusters

get

Retrieves a list of all K8s clusters provisioned under your account.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Responses
chevron-right
200

Successful operation

application/json
get
/k8s

Create a Kubernetes Cluster

post

Creates a K8s cluster provisioned under your account.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Body
idstringRead-onlyOptional

The resource unique identifier.

Example: 1e072e52-2ed3-492f-b6b6-c6b116907527
typestring · enumRead-onlyOptional

The object type.

Possible values:
hrefstring · uriRead-onlyOptional

The URL to the object representation (absolute path).

Example: https://api.ionos.com/cloudapi/v6/k8s/cc536834-b436-4b8e-b7d9-1e1473080057
Responses
post
/k8s

Get a Kubernetes Cluster by ID

get

Retrieves the K8s cluster specified by its ID.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the K8s cluster to be retrieved.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Responses
chevron-right
200

Successful operation

application/json
get
/k8s/{k8sClusterId}

Modify a Kubernetes Cluster by ID

put

Modifies the K8s cluster specified by its ID.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the Kubernetes cluster.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Body
idstringRead-onlyOptional

The resource's unique identifier.

Example: 1e072e52-2ed3-492f-b6b6-c6b116907527
typestring · enumRead-onlyOptional

The type of object.

Possible values:
hrefstring · uriRead-onlyOptional

URL to the object representation (absolute path).

Example: <RESOURCE-URI>
Responses
put
/k8s/{k8sClusterId}

Delete a Kubernetes Cluster by ID

delete

Deletes the K8s cluster specified by its ID.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the Kubernetes cluster.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Responses
delete
/k8s/{k8sClusterId}

No content

Get Kubernetes Configuration File

get

Retrieves the configuration file for the specified K8s cluster. You can define the format (YAML or JSON) of the returned file in the Accept header. By default, 'application/yaml' is specified.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the Kubernetes cluster.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Responses
chevron-right
200

Successful operation

Responsestring
get
/k8s/{k8sClusterId}/kubeconfig

Get Kubernetes Node Pools

get

Retrieves a list of K8s node pools of a cluster specified by its ID.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the Kubernetes cluster.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Responses
chevron-right
200

Successful operation

application/json
get
/k8s/{k8sClusterId}/nodepools

Create a Kubernetes Node Pool

post

Creates a node pool inside the specified K8s cluster.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the Kubernetes cluster.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Body
idstringRead-onlyOptional

The resource's unique identifier.

Example: 1e072e52-2ed3-492f-b6b6-c6b116907527
typestring · enumRead-onlyOptional

The object type.

Possible values:
hrefstring · uriRead-onlyOptional

The URL to the object representation (absolute path).

Example: https://api.ionos.com/cloudapi/v6/k8s/30f8a4f6-6515-4c34-b49d-dea807453b90/nodepools/4735f530-4279-42f3-9562-386143098038
Responses
post
/k8s/{k8sClusterId}/nodepools

Get a Kubernetes Node Pool by ID

get

Retrieves the K8s node pool specified by its ID.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the Kubernetes cluster.

nodepoolIdstringRequired

The unique ID of the Kubernetes node pool.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Responses
chevron-right
200

Successful operation

application/json
get
/k8s/{k8sClusterId}/nodepools/{nodepoolId}

Modify a Kubernetes Node Pool by ID

put

Modifies the K8s node pool specified by its ID.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the Kubernetes cluster.

nodepoolIdstringRequired

The unique ID of the Kubernetes node pool.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Body
idstringRead-onlyOptional

The resource's unique identifier.

Example: 1e072e52-2ed3-492f-b6b6-c6b116907527
typestring · enumRead-onlyOptional

The object type.

Possible values:
hrefstring · uriRead-onlyOptional

The URL to the object representation (absolute path).

Example: https://api.ionos.com/cloudapi/v6/k8s/30f8a4f6-6515-4c34-b49d-dea807453b90/nodepools/4735f530-4279-42f3-9562-386143098038
Responses
put
/k8s/{k8sClusterId}/nodepools/{nodepoolId}

Delete a Kubernetes Node Pool by ID

delete

Deletes the K8s node pool specified by its ID.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the Kubernetes cluster.

nodepoolIdstringRequired

The unique ID of the Kubernetes node pool.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Responses
delete
/k8s/{k8sClusterId}/nodepools/{nodepoolId}

No content

Get Kubernetes Nodes

get

Retrieves the list of all K8s nodes of the specified node pool.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the Kubernetes cluster.

nodepoolIdstringRequired

The unique ID of the Kubernetes node pool.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Responses
chevron-right
200

Successful operation

application/json
get
/k8s/{k8sClusterId}/nodepools/{nodepoolId}/nodes

Get Kubernetes Node by ID

get

Retrieves the K8s node specified by its ID.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the Kubernetes cluster.

nodepoolIdstringRequired

The unique ID of the Kubernetes node pool.

nodeIdstringRequired

The unique ID of the Kubernetes node.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Responses
chevron-right
200

Successful operation

application/json
get
/k8s/{k8sClusterId}/nodepools/{nodepoolId}/nodes/{nodeId}

Delete a Kubernetes Node by ID

delete

Deletes the K8s node specified by its ID.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the Kubernetes cluster.

nodepoolIdstringRequired

The unique ID of the Kubernetes node pool.

nodeIdstringRequired

The unique ID of the Kubernetes node.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Responses
delete
/k8s/{k8sClusterId}/nodepools/{nodepoolId}/nodes/{nodeId}

No content

Recreate a Kubernetes Node by ID

post

Recreates the K8s node specified by its ID.

If a node becomes unusable, Managed Kubernetes allows you to recreate it with a configuration based on the node pool template. Once the status is 'Active,' all the pods from the failed node will be migrated to the new node. The node pool has an additional billable 'active' node during this process.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Path parameters
k8sClusterIdstringRequired

The unique ID of the Kubernetes cluster.

nodepoolIdstringRequired

The unique ID of the Kubernetes node pool.

nodeIdstringRequired

The unique ID of the Kubernetes node.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Responses
post
/k8s/{k8sClusterId}/nodepools/{nodepoolId}/nodes/{nodeId}/replace

No content

Get Kubernetes Versions

get

Lists available K8s versions.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Responses
chevron-right
200

Successful operation

application/json
Responsestring[]
get
/k8s/versions

Get Default Kubernetes Version

get

Retrieves the current default K8s version to be used by the clusters and node pools.

Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials. Note:

Responses
chevron-right
200

Successful operation

application/json
ResponsestringExample: 1.21.4
get
/k8s/versions/default

Last updated

Was this helpful?